﻿using System;
using System.Threading;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buddy.BehaviorTree;
using Buddy.Common;
using Buddy.CommonBot;
using Buddy.Common.Math;
using Buddy.Common.Plugins;
using Buddy.Swtor;
using Buddy.Swtor.Objects;
using System.Windows;
using System.Diagnostics;


namespace Companion_Gifter
{
    class Companion_Gifter : IPlugin
    {
        
        #region Implementation of IEquatable<IPlugin>

        /// <summary>

        /// Indicates whether the current object is equal to another object of the same type.

        /// </summary>

        /// <returns>

        /// true if the current object is equal to the <paramref name="other"/> parameter; otherwise, false.

        /// </returns>

        /// <param name="other">An object to compare with this object.</param>

        public bool Equals(IPlugin other)
        {

            return other.Name == Name;

        }
        public static Form1 frm;


        #endregion

        #region Implementation of IPlugin

        public string Author { get { return "Wired"; } }

        public Version Version { get { return new Version(0, 2); } }

        public string Name { get { return "Companion Gift Giver"; } }

        public string Description { get { return "This will use the companion gift placed in selected slot and give to the active companion.  Load appropriate gifts for the active companion."; } }

        public Window DisplayWindow { get { return null; } }



        /// <summary> Executes the initialize action. This is called at initial bot startup. (When the bot itself is started, not when Start() is called) </summary>
        public void OnInitialize()
        {

        }
        
        /// <summary> Executes the pulse action. This is called every "tick" of the bot. </summary>
        public void OnPulse()
        {
        //    frm.Run();
        }


        public void OnStart()
        {

        }

        /// <summary> Executes the enabled action. This is called when the user has enabled this specific plugin via the GUI. </summary>
        public void OnEnabled()
        {
            //check if bot is running if so open form
            if (BotMain.IsRunning)
            {
                frm = new Form1();
                frm.Show();
            }
        }

        /// <summary> Executes the disabled action. This is called whent he user has disabled this specific plugin via the GUI. </summary>
        public void OnDisabled()
        {
            frm.Dispose();
            frm = null;
        }

        /// <summary> Executes the shutdown action. This is called when the bot is shutting down. (Not when Stop() is called) </summary>
        public void OnShutdown()
        {
            if (frm != null)
            {
                frm.Close();
                frm = null;
            }
            this.OnDisabled();
        }

        public void OnStop()
        {
            
        }

       


        


       


        #endregion


    }
}
